#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "tascend.h"

static void
NewTest(tester * tp, size_t num_elts)
{
   random_test * rtp = (random_test *)tp;
   size_t i;
   size_t key_size = rtp->elt_size;
   unsigned char * buf = (unsigned char *)malloc(key_size);

   memset((void *)buf, '\0', key_size);
   rtp->num_elts = num_elts;
   if (rtp->orig_data != NULL) {
      free(rtp->orig_data);
   }
   rtp->orig_data = malloc(rtp->elt_size * rtp->num_elts);
   for (i = 0; i < rtp->num_elts; ++i) {
      char * eltp = ((char *)rtp->orig_data) + (i * rtp->elt_size);
      unsigned char * endp = &buf[key_size - 1];
      unsigned int carry = 1;
      do {
         unsigned int val = *endp + carry;
         carry = (val >> 8);
         *endp-- = (unsigned char)(val & 0xff);
      } while ((carry != 0) && (endp != buf));
      memcpy((void *)eltp, (void *)buf, key_size);
   }
   free((void *)buf);
}

static void
Describe(tester * tp)
{
   printf("\n Data Generator = ascending\n");
}

tester *
MakeAscending(size_t elt_size)
{
   ascending_test * atp = (ascending_test *)malloc(sizeof(ascending_test));
   InitAscending(&(atp->random.base), elt_size);
   return &(atp->random.base);
}

void
InitAscending(tester * tp, size_t elt_size)
{
   ascending_test * atp = (ascending_test *)tp;
   InitRandom(&(atp->random.base), elt_size);
   atp->random.base.ftable_ptr->Describe = Describe;
   atp->random.base.ftable_ptr->NewTest = NewTest;
}

void
CleanAscending(tester * tp)
{
   CleanRandom(tp);
}
