#include <stdlib.h>
#include "tqsort.h"

extern void
test0qsort(void * array, size_t num_elts, size_t elt_size,
   int (*compare)(const void * elt1, const void * elt2));

extern void
test1qsort(void * array, size_t num_elts, size_t elt_size,
   int (*compare)(const void * elt1, const void * elt2));

extern void
test2qsort(void * array, size_t num_elts, size_t elt_size,
   int (*compare)(const void * elt1, const void * elt2));

extern void
test3qsort(void * array, size_t num_elts, size_t elt_size,
   int (*compare)(const void * elt1, const void * elt2));

extern void
test4qsort(void * array, size_t num_elts, size_t elt_size,
   int (*compare)(const void * elt1, const void * elt2));

size_t test_sizes[] = {0,1,2,3,341,999,1000,1001,10000,99996,200047,300722};

typedef tester * generator_routine(size_t elt_size);

generator_routine * test_gen[] = {
   MakeRandom,
   MakeAscending,
   MakeDescending,
   MakeRandup,
   MakeScrambled
};

int
main(int argc, char ** argv)
{
   int i, j;

   for ( j = 0;
         j < sizeof(test_gen)/sizeof(test_gen[0]);
         ++j ) {
      tester * tp = (*(test_gen[j]))(sizeof(int));
      for ( i = 0;
            i < sizeof(test_sizes)/sizeof(test_sizes[0]);
            ++i ) {
         NEW_TEST(tp, test_sizes[i]);
         TEST_SORT(tp, test0qsort, "plain");
         TEST_SORT(tp, test1qsort, "alg1");
         TEST_SORT(tp, test2qsort, "alg2");
         TEST_SORT(tp, test3qsort, "alg3");
         /* TEST_SORT(tp, test4qsort, "ins"); -- takes way too long */
         TEST_SORT(tp, qsort, "system");
      }
      DESTROY(tp);
   }
   return 0;
}
