#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "trandup.h"

static void
NewTest(tester * tp, size_t num_elts)
{
   random_test * rtp = (random_test *)tp;
   size_t i;

   rtp->num_elts = num_elts;
   if (rtp->orig_data != NULL) {
      free(rtp->orig_data);
   }
   rtp->orig_data = malloc(rtp->elt_size * rtp->num_elts);
   srand(0x1234beef);
   for (i = 0; i < rtp->num_elts; ++i) {
      char * eltp = ((char *)rtp->orig_data) + (i * rtp->elt_size);
      size_t elt_size = rtp->elt_size;
      memset((void *)eltp, (char)(rand() >> 3), elt_size);
   }
}

static void
Describe(tester * tp)
{
   printf("\n Data Generator = random with duplicates\n");
}

tester *
MakeRandup(size_t elt_size)
{
   randup_test * atp = (randup_test *)malloc(sizeof(randup_test));
   InitRandup(&(atp->random.base), elt_size);
   return &(atp->random.base);
}

void
InitRandup(tester * tp, size_t elt_size)
{
   randup_test * atp = (randup_test *)tp;
   InitRandom(&(atp->random.base), elt_size);
   atp->random.base.ftable_ptr->Describe = Describe;
   atp->random.base.ftable_ptr->NewTest = NewTest;
}

void
CleanRandup(tester * tp)
{
   CleanRandom(tp);
}
