#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "tscramble.h"

static void
NewTest(tester * tp, size_t num_elts)
{
   scramble_test * stp = (scramble_test *)tp;
   random_test * rtp = (random_test *)tp;
   size_t left, right;
   int up = 0;
   void * temp;
   (*(stp->prev_newtest))(tp, num_elts);
   if (num_elts <= 6) {
      return;
   }
   srand(0x1234beef);
   temp = malloc(rtp->elt_size);
   left = 0;
   right = num_elts - 1;
   while ((left < right) && ((right - left) > 30)) {
      size_t myleft;
      size_t myright;
      size_t mid = (left + right) / 2;
      size_t count;
      size_t limit;
      if (up) {
         myleft = left;
         myright = mid;
         left = mid + 1;
      } else {
         myleft = mid + 1;
         myright = right;
         right = mid;
      }
      up = ! up;
      count = ((myright - myleft) + 1) / 2;
      if (count > 6000) {
         count = 6000;
      }
      count -= 3;
      mid = (myleft + myright) / 2;
      myleft = mid - count;
      myright = mid + count;
      limit = count * 3;
      count = (myright - myleft) + 1;
      while (limit-- > 0) {
         size_t x1 = ((size_t)rand()) % count;
         size_t x2 = ((size_t)rand()) % count;
         char * p1 = ((char *)rtp->orig_data) + (x1 * rtp->elt_size);
         char * p2 = ((char *)rtp->orig_data) + (x2 * rtp->elt_size);
         memcpy(temp, (void *)p1, rtp->elt_size);
         memcpy((void *)p1, (void *)p2, rtp->elt_size);
         memcpy((void *)p2, temp, rtp->elt_size);
      }
   }
   free(temp);
}

static void
Describe(tester * tp)
{
   printf("\n Data Generator = ascending with scrambled regions\n");
}

tester *
MakeScrambled(size_t elt_size)
{
   scramble_test * stp = (scramble_test *)malloc(sizeof(scramble_test));
   InitScrambled(&(stp->ascend.random.base), elt_size);
   return &(stp->ascend.random.base);
}

void
InitScrambled(tester * tp, size_t elt_size)
{
   scramble_test * stp = (scramble_test *)tp;
   InitAscending(&(stp->ascend.random.base), elt_size);
   stp->prev_newtest = stp->ascend.random.base.ftable_ptr->NewTest;
   stp->ascend.random.base.ftable_ptr->Describe = Describe;
   stp->ascend.random.base.ftable_ptr->NewTest = NewTest;
}

void
CleanScrambled(tester * tp)
{
   CleanAscending(tp);
}
